sc::SimpleCo Class Referenceabstract

The SimpleCo abstract class describes a simple internal coordinate of a molecule. More...

`#include <simple.h>`

Inheritance diagram for sc::SimpleCo:
[legend]
Collaboration diagram for sc::SimpleCo:
[legend]

## Public Member Functions

| SimpleCo (int, const char *=0)
| This constructor takes an integer argument which is the number of atoms needed to describe the coordinate. More...
| SimpleCo (const Ref< KeyVal > &, int natom)
| The KeyVal constructor requires the number of atoms.
int | natoms () const
| Returns the number of atoms in the coordinate.
int | operator[] (int i) const
| Returns the index of the i'th atom in the coordinate.
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
| SimpleCo (StateIn &)
virtual int | operator== (SimpleCo &)
int | operator!= (SimpleCo &u)
double | force_constant (Ref< Molecule > &)
| Returns an approximate force constant (a la Almlof).
void | update_value (const Ref< Molecule > &)
| Recalculates the value of the coordinate based on the geometry in the Molecule. More...
void | bmat (const Ref< Molecule > &, RefSCVector &bmat, double coef=1.0)
| Fill in a row of the B matrix.
virtual double | calc_force_con (Molecule &)=0
| Calculates an approximate force constant and returns it's value.
virtual double | calc_intco (Molecule &, double *=0, double=1)=0
| Calculate the value of the coordinate based on what's in Molecule. More...
void | print_details (const Ref< Molecule > &, std::ostream &=ExEnv::out0()) const
| Print the coordinate.
int | equivalent (Ref< IntCoor > &)
| Tests to see if two coordinates are equivalent to each other. More...
Public Member Functions inherited from sc::IntCoor
| IntCoor (StateIn &)
| IntCoor (const IntCoor &)
| IntCoor (const char *label=0)
| This constructor takes a string containing a label for the internal coordinate. More...
| IntCoor (const Ref< KeyVal > &)
| The KeyVal constructor. More...
virtual const char * | label () const
| Returns the string containing the label for the internal coordinate.
virtual double | value () const
| Returns the value of the coordinate in atomic units or radians.
virtual void | set_value (double)
| Sets the value of the coordinate in atomic units or radians.
virtual double | preferred_value () const
| Returns the value of the coordinate in more familiar units.
virtual const char * | ctype () const =0
| Returns a string representation of the type of coordinate this is.
virtual void | print (std::ostream &o=ExEnv::out0()) const
| Print information about the coordinate.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Attributes

int | natoms_
int * | atoms
Protected Attributes inherited from sc::IntCoor
char * | label_
double | value_

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...
Static Protected Attributes inherited from sc::IntCoor
static double | bohr_conv
static double | radian_conv

## Detailed Description

The SimpleCo abstract class describes a simple internal coordinate of a molecule.

The number atoms involved can be 2, 3 or 4 and is determined by the specialization of SimpleCo.

There are three ways to specify the atoms involved in the internal coordinate. The first way is a shorthand notation, just a vector of a label followed by the atom numbers (starting at 1) is given. For example, a stretch between two atoms, 1 and 2, is given, in the ParsedKeyVal format, as

      stretch<StreSimpleCo>: [ R12 1 2 ]

The other two ways to specify the atoms are more general. With them, it is possible to give parameters for the IntCoor base class (and thus give the value of the coordinate). In the first of these input formats, a vector associated with the keyword atoms gives the atom numbers. The following specification for stretch is equivalent to that above:

      stretch<StreSimpleCo>:( label = R12 atoms = [ 1 2 ] )

In the second, a vector, atom_labels, is given along with a Molecule object. The atom labels are looked up in the Molecule object to find the atom numbers. The following specification for stretch is equivalent to those above:

      molecule<Molecule>: (
        { atom_labels atoms   geometry      } = {
              H1         H   [ 1.0 0.0 0.0 ]
              H2         H   [-1.0 0.0 0.0 ] } )
      stretch<StreSimpleCo>:( label = R12
                              atom_labels = [ H1 H2 ]
                              molecule = $:molecule )

## Constructor & Destructor Documentation

sc::SimpleCo::SimpleCo | ( | int | ,
|  | const char * | = `0`
| ) |  |

This constructor takes an integer argument which is the number of atoms needed to describe the coordinate.

A second optional char* argument is a label for the coordinate. This argument is passed on to the IntCoor constructor.

## Member Function Documentation

virtual double sc::SimpleCo::calc_intco | ( | Molecule & | ,
|  | double * | = `0`,
|  | double | = `1`
| ) |  |

pure virtual

Calculate the value of the coordinate based on what's in Molecule.

If given a double*, fill in that part of the B matrix. If the bmatrix is to be calculated, the third argument gives the coefficient.

int sc::SimpleCo::equivalent | ( | Ref< IntCoor > & |  | ) |

virtual

Tests to see if two coordinates are equivalent to each other.

This is false if the atoms don't match.

Implements sc::IntCoor.

void sc::SimpleCo::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::IntCoor.

void sc::SimpleCo::update_value | ( | const Ref< Molecule > & |  | ) |

virtual

Recalculates the value of the coordinate based on the geometry in the Molecule.

Implements sc::IntCoor.

The documentation for this class was generated from the following file:

- simple.h